#ifndef LIBWCCL_OPS_ACTION_H
#define LIBWCCL_OPS_ACTION_H

#include <boost/shared_ptr.hpp>
#include <boost/assert.hpp>
#include <boost/mpl/assert.hpp>
#include <boost/type_traits/is_base_of.hpp>

#include <libwccl/ops/expression.h>
#include <libwccl/values/value.h>
#include <libwccl/ops/actionexeccontext.h>

namespace Wccl {

/**
 * Abstract base class for actions in WCCL rules
 */
class Action : public Expression
{
public:
	/**
	 * @returns Name of the action.
	 */
	virtual std::string name(const Corpus2::Tagset&) const = 0;
	/**
	 * Executes the action for the given execution context.
	 */
	virtual Bool execute(const ActionExecContext& context) const = 0;
};

} /* end ns Wccl */

#endif // LIBWCCL_OPS_ACTION_H
